WordPress gets constantly updated and every update brings new features and fixes bugs.

Will the plugin no longer work with a WordPress version which is no longer supported?

No, if the plugin worked in the past it will most likely work in the future. Sometimes features not available in this version will cause an error which no longer get fixed. Also there’s no dedicate test for deprecated version.

In general I recommend to keep your WordPress site and it’s plugins up to date to prevent security vulnerability.

Read more about updating WordPress.